/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NUMBER = 258,
     ID = 259,
     STRING = 260,
     LEFTARROW = 261,
     RIGHTARROW = 262,
     INPUT = 263,
     OUTPUT = 264,
     ALIASES = 265,
     STATES = 266,
     TABLES = 267,
     EXPRESSIONS = 268,
     PUSH = 269,
     POP = 270,
     DIV = 271,
     MOD = 272,
     BEG = 273,
     END = 274
   };
#endif
#define NUMBER 258
#define ID 259
#define STRING 260
#define LEFTARROW 261
#define RIGHTARROW 262
#define INPUT 263
#define OUTPUT 264
#define ALIASES 265
#define STATES 266
#define TABLES 267
#define EXPRESSIONS 268
#define PUSH 269
#define POP 270
#define DIV 271
#define MOD 272
#define BEG 273
#define END 274




/* Copy the first part of user declarations.  */
#line 1 "./otp.y"

/* otp.y: Grammar for OTP files.

This file is part of Omega,
which is based on the web2c distribution of TeX,

Copyright (c) 1994--2001 John Plaice and Yannis Haralambous

Omega is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Omega is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Omega; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

*/

#include "otp.h"
#include "routines.h"
#include "yystype.h"
int k, len;

void yyerror(char * msg)
{
fprintf(stderr, "line %d: %s\n", line_number, msg);
}


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 159 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   177

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  40
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  36
/* YYNRULES -- Number of rules. */
#define YYNRULES  85
/* YYNRULES -- Number of states. */
#define YYNSTATES  159

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   274

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,    39,    38,     2,     2,     2,
      34,    35,    22,    20,    29,    21,    32,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    23,
      30,    26,    31,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    24,    37,    25,    33,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    27,    36,    28,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,    10,    11,    15,    16,    20,    21,    24,
      26,    29,    30,    41,    42,    44,    46,    50,    51,    55,
      57,    61,    62,    65,    67,    70,    75,    77,    84,    90,
      92,    94,    98,   100,   105,   109,   113,   115,   119,   122,
     124,   127,   128,   129,   130,   141,   142,   145,   146,   150,
     154,   157,   158,   160,   161,   163,   165,   168,   169,   172,
     174,   176,   179,   182,   189,   192,   199,   206,   215,   218,
     220,   224,   228,   232,   236,   240,   241,   247,   249,   252,
     255,   262,   266,   267,   271,   276
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      41,     0,    -1,    42,    43,    44,    50,    52,    58,    -1,
      -1,     8,     3,    23,    -1,    -1,     9,     3,    23,    -1,
      -1,    12,    45,    -1,    46,    -1,    45,    46,    -1,    -1,
       4,    24,     3,    25,    47,    26,    27,    48,    28,    23,
      -1,    -1,    49,    -1,     3,    -1,    49,    29,     3,    -1,
      -1,    11,    51,    23,    -1,     4,    -1,    51,    29,     4,
      -1,    -1,    10,    53,    -1,    54,    -1,    53,    54,    -1,
       4,    26,    55,    23,    -1,     5,    -1,    56,    30,     3,
      29,     3,    31,    -1,    56,    30,     3,    29,    31,    -1,
      56,    -1,     3,    -1,     3,    21,     3,    -1,    32,    -1,
      33,    34,    57,    35,    -1,    34,    57,    35,    -1,    27,
       4,    28,    -1,    56,    -1,    57,    36,    56,    -1,    13,
      59,    -1,    60,    -1,    59,    60,    -1,    -1,    -1,    -1,
      65,    61,    66,    62,     7,    70,    63,    64,    75,    23,
      -1,    -1,     6,    70,    -1,    -1,    30,     4,    31,    -1,
      67,    69,    68,    -1,    67,    68,    -1,    -1,    18,    -1,
      -1,    19,    -1,    55,    -1,    69,    55,    -1,    -1,    70,
      71,    -1,     5,    -1,     3,    -1,    37,     3,    -1,    37,
      38,    -1,    37,    34,    38,    21,     3,    35,    -1,    37,
      22,    -1,    37,    34,    22,    20,     3,    35,    -1,    37,
      34,    22,    21,     3,    35,    -1,    37,    34,    22,    20,
       3,    21,     3,    35,    -1,    39,    74,    -1,    74,    -1,
      72,    20,    74,    -1,    72,    21,    74,    -1,    72,    22,
      74,    -1,    72,    16,    74,    -1,    72,    17,    74,    -1,
      -1,     4,    73,    24,    72,    25,    -1,     3,    -1,    37,
       3,    -1,    37,    38,    -1,    37,    34,    38,    21,     3,
      35,    -1,    34,    72,    35,    -1,    -1,    30,     4,    31,
      -1,    30,    14,     4,    31,    -1,    30,    15,    31,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    60,    60,    70,    71,    77,    78,    82,    84,    88,
      89,    94,    93,    98,   100,   104,   106,   110,   112,   116,
     118,   122,   124,   128,   129,   133,   138,   140,   142,   144,
     149,   151,   153,   155,   157,   159,   164,   166,   171,   186,
     187,   192,   194,   196,   191,   201,   203,   208,   209,   214,
     216,   222,   223,   229,   230,   235,   237,   241,   243,   247,
     254,   256,   258,   260,   262,   267,   272,   277,   282,   287,
     288,   290,   292,   294,   296,   299,   298,   305,   307,   309,
     311,   313,   316,   318,   320,   322
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUMBER", "ID", "STRING", "LEFTARROW", 
  "RIGHTARROW", "INPUT", "OUTPUT", "ALIASES", "STATES", "TABLES", 
  "EXPRESSIONS", "PUSH", "POP", "DIV", "MOD", "BEG", "END", "'+'", "'-'", 
  "'*'", "';'", "'['", "']'", "'='", "'{'", "'}'", "','", "'<'", "'>'", 
  "'.'", "'^'", "'('", "')'", "'|'", "'\\\\'", "'$'", "'#'", "$accept", 
  "File", "Input", "Output", "Tables", "MoreTables", "OneTable", "@1", 
  "Numbers", "MoreNumbers", "States", "MoreStates", "Aliases", 
  "MoreAliases", "OneAlias", "OneCompleteLeft", "OneLeft", "ChoiceLeft", 
  "Expressions", "MoreExpressions", "OneExpr", "@2", "@3", "@4", 
  "PushBack", "LeftState", "TotalLeft", "BegLeft", "EndLeft", "Left", 
  "Right", "OneRight", "RestRightExpr", "@5", "OneRightExpr", 
  "RightState", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      43,    45,    42,    59,    91,    93,    61,   123,   125,    44,
      60,    62,    46,    94,    40,    41,   124,    92,    36,    35
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    40,    41,    42,    42,    43,    43,    44,    44,    45,
      45,    47,    46,    48,    48,    49,    49,    50,    50,    51,
      51,    52,    52,    53,    53,    54,    55,    55,    55,    55,
      56,    56,    56,    56,    56,    56,    57,    57,    58,    59,
      59,    61,    62,    63,    60,    64,    64,    65,    65,    66,
      66,    67,    67,    68,    68,    69,    69,    70,    70,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    72,
      72,    72,    72,    72,    72,    73,    72,    74,    74,    74,
      74,    74,    75,    75,    75,    75
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     6,     0,     3,     0,     3,     0,     2,     1,
       2,     0,    10,     0,     1,     1,     3,     0,     3,     1,
       3,     0,     2,     1,     2,     4,     1,     6,     5,     1,
       1,     3,     1,     4,     3,     3,     1,     3,     2,     1,
       2,     0,     0,     0,    10,     0,     2,     0,     3,     3,
       2,     0,     1,     0,     1,     1,     2,     0,     2,     1,
       1,     2,     2,     6,     2,     6,     6,     8,     2,     1,
       3,     3,     3,     3,     3,     0,     5,     1,     2,     2,
       6,     3,     0,     3,     4,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       3,     0,     0,     5,     0,     1,     0,     7,     4,     0,
       0,    17,     6,     0,     8,     9,     0,    21,     0,    10,
      19,     0,     0,     0,     0,    18,     0,     0,    22,    23,
      47,     2,    11,    20,     0,    24,     0,    47,    39,    41,
       0,    30,    26,     0,    32,     0,     0,     0,    29,     0,
      40,    51,     0,     0,     0,     0,    36,     0,    25,     0,
      48,    52,    42,    53,    13,    31,    35,     0,    34,     0,
       0,     0,    54,    55,    50,    53,    15,     0,    14,    33,
      37,     0,    57,    56,    49,     0,     0,     0,    28,    43,
      12,    16,    27,    60,    59,     0,     0,    45,    58,    61,
      64,     0,    62,    77,     0,     0,    68,    57,    82,     0,
       0,    75,     0,    69,    78,     0,    79,    46,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    81,
       0,     0,     0,     0,    44,     0,     0,     0,     0,    73,
      74,    70,    71,    72,     0,    83,     0,    85,     0,    65,
      66,    63,     0,     0,    84,     0,    76,    80,    67
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     2,     3,     7,    11,    14,    15,    40,    77,    78,
      17,    21,    23,    28,    29,    47,    48,    57,    31,    37,
      38,    51,    71,    97,   108,    39,    62,    63,    74,    75,
      89,    98,   112,   123,   113,   119
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -96
static const yysigned_char yypact[] =
{
       0,    10,    18,    11,    44,   -96,    54,    53,   -96,    48,
      81,    75,   -96,    64,    81,   -96,    85,    80,    88,   -96,
     -96,    43,    89,    79,    69,   -96,    91,    70,    89,   -96,
      67,   -96,   -96,   -96,    22,   -96,    94,    17,   -96,   -96,
      73,    82,   -96,    96,   -96,    68,    41,    78,    74,    76,
     -96,    87,    83,   103,    84,    41,   -96,   -20,   -96,   105,
     -96,   -96,   -96,    19,   106,   -96,   -96,    34,   -96,    41,
      86,   104,   -96,   -96,   -96,    19,   -96,    90,    92,   -96,
     -96,    45,   -96,   -96,   -96,    93,   110,    95,   -96,    -3,
     -96,   -96,   -96,   -96,   -96,     1,     8,   108,   -96,   -96,
     -96,   -17,   -96,   -96,     6,     3,   -96,   -96,    97,    60,
      98,   -96,    42,   -96,   -96,    99,   -96,    -3,    46,   100,
     114,   117,   119,   101,     8,     8,     8,     8,     8,   -96,
     107,   102,   120,   109,   -96,    -7,   111,   112,     6,   -96,
     -96,   -96,   -96,   -96,   126,   -96,   113,   -96,   127,   -96,
     -96,   -96,    62,   115,   -96,   116,   -96,   -96,   -96
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -96,   -96,   -96,   -96,   -96,   -96,   118,   -96,   -96,   -96,
     -96,   -96,   -96,   -96,   121,   -56,   -43,   122,   -96,   -96,
     123,   -96,   -96,   -96,   -96,   -96,   -96,   -96,    56,   -96,
      27,   -96,    -2,   -96,   -95,   -96
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -39
static const short yytable[] =
{
      93,   106,    94,    56,    99,   109,   114,    73,     1,   103,
     111,   103,    56,     4,   148,    68,    69,   -38,     5,    83,
       6,   110,    41,   100,    42,    41,    80,    42,   149,   139,
     140,   141,   142,   143,    95,   101,    96,   115,    72,   102,
     104,   116,   104,   105,    41,   105,    43,    36,    87,    43,
     131,    44,    45,    46,    44,    45,    46,     9,   124,   125,
     132,   133,   126,   127,   128,    10,    25,     8,    43,    79,
      69,    12,    26,    44,    45,    46,    88,   129,   124,   125,
     120,   121,   126,   127,   128,    13,    16,   156,    18,    20,
      22,    24,    30,    27,    32,    33,    34,    36,    49,    52,
      54,    58,    55,    53,    59,    61,    65,    60,    70,    76,
      64,    82,    66,    91,   107,    81,    90,   135,    85,   122,
     136,    86,   137,   134,   146,   138,    92,   118,   144,   153,
     155,    84,    19,   145,   117,     0,   152,   130,     0,     0,
     147,     0,     0,     0,   154,     0,   150,   151,     0,    35,
     157,   158,     0,     0,     0,     0,     0,     0,     0,     0,
      50,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    67
};

static const short yycheck[] =
{
       3,    96,     5,    46,     3,    22,     3,    63,     8,     3,
       4,     3,    55,     3,    21,    35,    36,     0,     0,    75,
       9,    38,     3,    22,     5,     3,    69,     5,    35,   124,
     125,   126,   127,   128,    37,    34,    39,    34,    19,    38,
      34,    38,    34,    37,     3,    37,    27,    30,     3,    27,
       4,    32,    33,    34,    32,    33,    34,     3,    16,    17,
      14,    15,    20,    21,    22,    12,    23,    23,    27,    35,
      36,    23,    29,    32,    33,    34,    31,    35,    16,    17,
      20,    21,    20,    21,    22,     4,    11,    25,    24,     4,
      10,     3,    13,     4,    25,     4,    26,    30,     4,    26,
       4,    23,    34,    21,    30,    18,     3,    31,     3,     3,
      27,     7,    28,     3,     6,    29,    23,     3,    28,    21,
       3,    29,     3,    23,     4,    24,    31,    30,    21,     3,
       3,    75,    14,    31,   107,    -1,   138,    38,    -1,    -1,
      31,    -1,    -1,    -1,    31,    -1,    35,    35,    -1,    28,
      35,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    55
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     8,    41,    42,     3,     0,     9,    43,    23,     3,
      12,    44,    23,     4,    45,    46,    11,    50,    24,    46,
       4,    51,    10,    52,     3,    23,    29,     4,    53,    54,
      13,    58,    25,     4,    26,    54,    30,    59,    60,    65,
      47,     3,     5,    27,    32,    33,    34,    55,    56,     4,
      60,    61,    26,    21,     4,    34,    56,    57,    23,    30,
      31,    18,    66,    67,    27,     3,    28,    57,    35,    36,
       3,    62,    19,    55,    68,    69,     3,    48,    49,    35,
      56,    29,     7,    55,    68,    28,    29,     3,    31,    70,
      23,     3,    31,     3,     5,    37,    39,    63,    71,     3,
      22,    34,    38,     3,    34,    37,    74,     6,    64,    22,
      38,     4,    72,    74,     3,    34,    38,    70,    30,    75,
      20,    21,    21,    73,    16,    17,    20,    21,    22,    35,
      38,     4,    14,    15,    23,     3,     3,     3,    24,    74,
      74,    74,    74,    74,    21,    31,     4,    31,    21,    35,
      35,    35,    72,     3,    31,     3,    25,    35,    35
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 70 "./otp.y"
    { input_bytes=2; }
    break;

  case 4:
#line 72 "./otp.y"
    { input_bytes=yyvsp[-1].yint; }
    break;

  case 5:
#line 77 "./otp.y"
    { output_bytes=2; }
    break;

  case 6:
#line 79 "./otp.y"
    { output_bytes=yyvsp[-1].yint; }
    break;

  case 11:
#line 94 "./otp.y"
    { store_table(yyvsp[-3].ystring, yyvsp[-1].yint); }
    break;

  case 15:
#line 105 "./otp.y"
    { add_to_table(yyvsp[0].yint); }
    break;

  case 16:
#line 107 "./otp.y"
    { add_to_table(yyvsp[0].yint); }
    break;

  case 19:
#line 117 "./otp.y"
    { store_state(yyvsp[0].ystring); }
    break;

  case 20:
#line 119 "./otp.y"
    { store_state(yyvsp[0].ystring); }
    break;

  case 25:
#line 134 "./otp.y"
    { store_alias(yyvsp[-3].ystring, yyvsp[-1].yleft); }
    break;

  case 26:
#line 139 "./otp.y"
    { yyval.yleft = StringLeft(yyvsp[0].ystring); }
    break;

  case 27:
#line 141 "./otp.y"
    { yyval.yleft = CompleteLeft(yyvsp[-5].yleft, yyvsp[-3].yint, yyvsp[-1].yint); }
    break;

  case 28:
#line 143 "./otp.y"
    { yyval.yleft = PlusLeft(yyvsp[-4].yleft, yyvsp[-2].yint); }
    break;

  case 29:
#line 145 "./otp.y"
    { yyval.yleft = yyvsp[0].yleft; }
    break;

  case 30:
#line 150 "./otp.y"
    { yyval.yleft = SingleLeft(yyvsp[0].yint); }
    break;

  case 31:
#line 152 "./otp.y"
    { yyval.yleft = DoubleLeft(yyvsp[-2].yint, yyvsp[0].yint); }
    break;

  case 32:
#line 154 "./otp.y"
    { yyval.yleft = WildCard(); }
    break;

  case 33:
#line 156 "./otp.y"
    { yyval.yleft = NotChoiceLeft(yyvsp[-1].ylleft); }
    break;

  case 34:
#line 158 "./otp.y"
    { yyval.yleft = ChoiceLeft(yyvsp[-1].ylleft); }
    break;

  case 35:
#line 160 "./otp.y"
    { yyval.yleft = lookup_alias(yyvsp[-1].ystring); }
    break;

  case 36:
#line 165 "./otp.y"
    { yyval.ylleft = llist1(yyvsp[0].yleft); }
    break;

  case 37:
#line 167 "./otp.y"
    { yyval.ylleft = lappend1(yyvsp[-2].ylleft, yyvsp[0].yleft); }
    break;

  case 38:
#line 172 "./otp.y"
    {
	  for(cur_state=0; cur_state<no_states; cur_state++) {
		  if ((states[cur_state].no_exprs)==0) {
        	     out_int(OTP_LEFT_START, 0);
		  } else {
        	     out_int(OTP_LEFT_RETURN, 0);
                  }
		  out_int(OTP_RIGHT_CHAR, 1);
		  out_int(OTP_STOP, 0);
	  }
	}
    break;

  case 41:
#line 192 "./otp.y"
    { states[cur_state].no_exprs++; }
    break;

  case 42:
#line 194 "./otp.y"
    { out_left(yyvsp[0].ylleft); right_offset=0; }
    break;

  case 43:
#line 196 "./otp.y"
    { right_offset=OTP_PBACK_OFFSET; }
    break;

  case 44:
#line 198 "./otp.y"
    { fill_in_left(); }
    break;

  case 47:
#line 208 "./otp.y"
    { cur_state = 0; }
    break;

  case 48:
#line 210 "./otp.y"
    { cur_state = lookup_state(yyvsp[-1].ystring); }
    break;

  case 49:
#line 215 "./otp.y"
    { yyval.ylleft = lappend(yyvsp[-2].ylleft, lappend(yyvsp[-1].ylleft, yyvsp[0].ylleft)); }
    break;

  case 50:
#line 217 "./otp.y"
    { yyval.ylleft = lappend(yyvsp[-1].ylleft, yyvsp[0].ylleft); }
    break;

  case 51:
#line 222 "./otp.y"
    { yyval.ylleft = nil; }
    break;

  case 52:
#line 224 "./otp.y"
    { yyval.ylleft = llist1(BeginningLeft()); }
    break;

  case 53:
#line 229 "./otp.y"
    { yyval.ylleft = nil; }
    break;

  case 54:
#line 231 "./otp.y"
    { yyval.ylleft = llist1(EndLeft()); }
    break;

  case 55:
#line 236 "./otp.y"
    { yyval.ylleft = llist1(yyvsp[0].yleft); }
    break;

  case 56:
#line 238 "./otp.y"
    { yyval.ylleft = lappend1(yyvsp[-1].ylleft, yyvsp[0].yleft); }
    break;

  case 59:
#line 248 "./otp.y"
    {
	 len=strlen(yyvsp[0].ystring);
	 for (k=0; k<len; k++) {
            out_right(OTP_RIGHT_NUM, (yyvsp[0].ystring)[k]);
         }
	}
    break;

  case 60:
#line 255 "./otp.y"
    { out_right(OTP_RIGHT_NUM, yyvsp[0].yint); }
    break;

  case 61:
#line 257 "./otp.y"
    { out_right(OTP_RIGHT_CHAR, yyvsp[0].yint); }
    break;

  case 62:
#line 259 "./otp.y"
    { out_right(OTP_RIGHT_LCHAR, 0); }
    break;

  case 63:
#line 261 "./otp.y"
    { out_right(OTP_RIGHT_LCHAR, yyvsp[-1].yint); }
    break;

  case 64:
#line 263 "./otp.y"
    {
	 out_right(OTP_RIGHT_SOME, 0); 
	 out_int(0,0);
	}
    break;

  case 65:
#line 268 "./otp.y"
    {
	 out_right(OTP_RIGHT_SOME, yyvsp[-1].yint);
	 out_int(0, 0);
	}
    break;

  case 66:
#line 273 "./otp.y"
    {
	 out_right(OTP_RIGHT_SOME, 0);
	 out_int(0, yyvsp[-1].yint);
	}
    break;

  case 67:
#line 278 "./otp.y"
    {
	 out_right(OTP_RIGHT_SOME, yyvsp[-3].yint);
	 out_int(0, yyvsp[-1].yint);
	}
    break;

  case 68:
#line 283 "./otp.y"
    { out_right(OTP_RIGHT_OUTPUT, 0); }
    break;

  case 70:
#line 289 "./otp.y"
    { out_int(OTP_ADD, 0); }
    break;

  case 71:
#line 291 "./otp.y"
    { out_int(OTP_SUB, 0); }
    break;

  case 72:
#line 293 "./otp.y"
    { out_int(OTP_MULT, 0); }
    break;

  case 73:
#line 295 "./otp.y"
    { out_int(OTP_DIV, 0); }
    break;

  case 74:
#line 297 "./otp.y"
    { out_int(OTP_MOD, 0); }
    break;

  case 75:
#line 299 "./otp.y"
    { out_int(OTP_PUSH_NUM, lookup_table(yyvsp[0].ystring)); }
    break;

  case 76:
#line 301 "./otp.y"
    { out_int(OTP_LOOKUP, 0); }
    break;

  case 77:
#line 306 "./otp.y"
    { out_int(OTP_PUSH_NUM, yyvsp[0].yint); }
    break;

  case 78:
#line 308 "./otp.y"
    { out_int(OTP_PUSH_CHAR, yyvsp[0].yint); }
    break;

  case 79:
#line 310 "./otp.y"
    { out_int(OTP_PUSH_LCHAR, 0); }
    break;

  case 80:
#line 312 "./otp.y"
    { out_int(OTP_PUSH_LCHAR, yyvsp[-1].yint); }
    break;

  case 83:
#line 319 "./otp.y"
    { out_int(OTP_STATE_CHANGE, lookup_state(yyvsp[-1].ystring)); }
    break;

  case 84:
#line 321 "./otp.y"
    { out_int(OTP_STATE_PUSH, lookup_state(yyvsp[-1].ystring)); }
    break;

  case 85:
#line 323 "./otp.y"
    { out_int(OTP_STATE_POP, 0); }
    break;


    }

/* Line 991 of yacc.c.  */
#line 1510 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__)
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 325 "./otp.y"


